/*
	Hello Web 3 - The Button Strikes!
	Exploring Java - Niemeyer & Peck
*/

import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;

public class HelloWeb3b extends Applet {
	int messageX, messageY;
	String theMessage;
	Button theButton;
	int colorIndex = 0;
	static Color[] someColors = {
		Color.black, Color.red, Color.green, Color.blue, Color.magenta };
		
	public void init() {
		theMessage = getParameter("message");
		theButton = new Button("Change Color");
		add( theButton );
	}
	
	public void paint( Graphics g ) {
		g.drawString( theMessage, messageX, messageY );
	}
		
	public  boolean mouseDrag(Event e, int x, int y) {
		messageX = x;
		messageY = y;
		repaint();
		return true;
	}

	public boolean action( Event e, Object arg  ) {
		// If theButton was clicked on, handle it,
		// otherwise let our superclass handle it if it wants to.
		if ( e.target == theButton ) {
			changeColor();
			return true;
		}
		else return super.action(e, arg);
	}

	synchronized private void changeColor() {
		if ( ++colorIndex == someColors.length )
			colorIndex = 0;
		setForeground( currentColor() );
		repaint();
	}

	synchronized private Color currentColor() {
		return someColors[ colorIndex ];
	}
}
