/*
	This application illustrates inheritance, polymorphism,
	and abstract classes.
	
	Custom classes: ShapeApp
				Shape				a common abstract ancestor
                Rectangle           defines and draws rectangles
                Ellipse             defines and draws ellipses
                Square              defines and draws squares

*/

import java.awt.Color;
import ShapePack.*;

public class ShapeApp2 {

	public static void main(String args[]) {
		Shape a, b, c, d;

		printHead();
		
		System.out.println( "Set 'a' to a new default rectangle." );
		a = new myRectangle(10,10);
		outputStuff( a );

		System.out.println( "Set 'b' to a new rectangle." );
		b = new myRectangle(20, 20, 15, 30, Color.blue);
		outputStuff( b );

		System.out.println( "Move 'b' to (75,25)." );
		b.moveTo(75, 25);
		outputStuff( b );

		System.out.println( "Change 'a' to the same size as 'b'." );
		// a.wide = b.wide;
		a.setWidth( b.getWidth() );
		// a.high = b.high;
		a.setHeight( b.getHeight() );
		outputStuff( a );
		
		System.out.println( "Set 'c' to a new default ellipse." );
		c = new myEllipse(30, 30);
		outputStuff( c );
		
		System.out.println( "Reset 'a' to a new ellipse." );
		a = new myEllipse(50, 50, 100, 50, Color.green);
		outputStuff( a );
		
		System.out.println( "Set 'd' to a new default square." );
		d = new mySquare(40, 40);
		outputStuff( d );
		
		System.out.println( "Try to do a bad thing - stretch the square, 'd'." );
		// d.wide = 2*d.wide;
		d.setHeight( 2*d.getHeight() );
		outputStuff( d );
		
		printTail();
		
	}
	
	public static void outputStuff( Shape x ) {
		System.out.println( x );
		System.out.println( "Area: " + x.area());
		System.out.println( "Perimeter: " + x.perimeter());
		System.out.println( );
	}
	
	public static void printHead() {
		System.out.println( "Content-type: text/html" );
		System.out.println( "" );
		System.out.println( "<html>" );
		System.out.println( "<head>" );
		System.out.println( "<title>ShapeApp Example</title>" );
		System.out.println( "</head>" );
		System.out.println( "<body bgcolor=\"#FFFFFF\" alink=\"#0080FF\">" );
		System.out.println( "<h1>Shape Application</h1>" );
		System.out.println( "<blockquote><pre><tt>" );
		
	}
	
	public static void printTail() {
		System.out.println( "</tt></pre></blockquote>" );
		System.out.println( "<hr> <h3>The source codes.</h3><blockquote>");
		System.out.println( "<a href=\"ShapeApp2.java\">ShapeApp2.java</a><br>");
		System.out.println( "<a href=\"Shape.java\">Shape.java</a><br>");
		System.out.println( "<a href=\"myRectangle.java\">myRectangle.java</a><br>");
		System.out.println( "<a href=\"myEllipse.java\">myEllipse.java</a><br>");
		System.out.println( "<a href=\"mySquare.java\">mySquare.java</a><br>");
		System.out.println( "</blockquote></body>" );
		System.out.println( "</html>" );
	}

}

