import java.io.*;

public class LexMachine {
   FileReader fr;
   StreamTokenizer st;

   public LexMachine(String filename) 
      throws IOException {
      fr = new FileReader(filename);
      st = new StreamTokenizer(fr);
      st.ordinaryChar('.');
      st.ordinaryChar('-');
   }

   public TokenValue getNext() 
      throws IOException {
      int token;
      TokenValue tv;
      Double myNum;
      if ((token = st.nextToken()) != StreamTokenizer.TT_EOF) {
         if (token == StreamTokenizer.TT_NUMBER) {
            myNum = new Double(st.nval);
            tv = new TokenValue(token,myNum);
         } else if (token == StreamTokenizer.TT_WORD) {
            tv = new TokenValue(token,st.sval);
         } else {
            tv = new TokenValue(token);
         }
         return tv;
      } else {
         return null;
      }
   }
}

