import java.util.*;
import java.lang.reflect.Array;

public class CTStack extends M865Stack {
     	public static final int initCap = 100;
    	protected Vector s;

       
     	public CTStack(int capacity, int increment) {
        	s = new Vector(capacity, increment);
      }

     	public CTStack(int capacity) {
         	s = new Vector(capacity);
      }

   	public CTStack() {
     		this(initCap);
    	}

	protected CTStack (Vector v) {
		s = (Vector)v.clone();
	}
       

//push

	public void push(Object o) {
		s.addElement(o);
	}

   	public Object pop() {
		Object x;
		if(s.isEmpty()) {
			x=null;
		}
		else {
			x=s.lastElement();
			s.removeElementAt(s.size()-1);
		}
		return x;
	}
        
        
//peek

	public Object peek(){
		return s.lastElement();
	}


//add

    public boolean add(Object o) {
       	
		this.push(o);
		return true;
	}

     		
//addAll

	public boolean addAll(Collection c) {
		Iterator ci = c.iterator();
		boolean changed = ci.hasNext();
		while(ci.hasNext()) {
			this.push(ci.next());
		}
		return changed;
	}	


//clear

      	public void clear() {
      		s.clear();
      	}
      	
        
//contains

      	public boolean contains(Object o){
       		return s.contains(o);
       	}
        
        
//containsAll

    	public boolean containsAll(Collection c) {
    		return s.containsAll(c);
    	}
    	
        
//equals

	public boolean equals(Object o) {
            if(o instanceof Vector && (this.size() == ((Vector)o).size()))
                {
                Iterator thisIterator = this.iterator();
                Iterator oIterator = ((Vector)o).iterator();
                while(thisIterator.hasNext() || oIterator.hasNext()) {
                    if(thisIterator.next() != oIterator.next())
                        return false;
                }
                return true;
            }
            else
                return false;
        }


//Iterator

        public Iterator iterator() {
             return new CTStackIterator(s);
        }


//hashCode

       public int hashCode() {
            return s.hashCode();
        }
        
        
//isEmpty

      	public boolean isEmpty() {
      		return s.isEmpty();
      	}
      	
       
//remove

      public boolean remove(Object o) {
      
     		throw(new UnsupportedOperationException("You do not have the ability to remove an item"));
     	}
     	
//removeAll

     	public boolean removeAll(Collection c){
		throw(new UnsupportedOperationException("You do not have the ability to remove all items"));
     	}


//retainAll

     	public boolean retainAll(Collection c){
		throw(new UnsupportedOperationException("You do not have the ability to retain all items"));
     	}

//size

      	public int size() {
      		return s.size();
      	}
      	
//Object[] toArray()

     	public Object[] toArray() {
	int n=s.size();
		Object[] A= new Object[n];
	for (int i=0;i<n;i++) {
                    A[n-i-1]=s.get(i);
                }
                return A;
	}
            

//Object[] toArray(Object[] a)
//copied this in class on Friday. Understand the first part, but it gets a little fuzzy after the "else" statement
     	public Object[] toArray(Object[] a) {
		int i = s.size();
		int k=0;
		if(i<=a.length) {
			while (0<i) {
				a[k++] = s.get(--i);
			}
			if(s.size()<a.length) {
				a[k]=null;
			}
			return a;
                       
		} else {
			Class c = a.getClass();
			c = c.getComponentType();
			Object[] A = (Object[])Array.newInstance(c,i);
			while (0<i) {
				A[k++] = s.get(--i);
			}

			return A;
		}
	}
//toString
	public String toString() {
		String name = "'";
                if (s.size()==0) {
                    name+="'";
                    return name;
                }
                else {
                    for(int k=0;k<s.size()-1;k++) {
                        name+=s.get(k)+" ,";
                    }
                    name+=s.lastElement()+"'";
                    return name;
                }
        }

 
//Clone
//copied this in class on Friday - makes sense...
	public Object clone () {
		return(new CTStack(s));
	}
        
// Iterator
  public class CTStackIterator implements Iterator {
            private Vector v;
            private int index;

            CTStackIterator(Vector v) {
		this.v=v;
		int index = v.size();
		int check = v.hashCode();
            }
                public boolean hasNext() {
                    return (0<index);
                }
	
                public Object next() {
                    return v.get(--index);
                }

               public void remove() {
     		throw(new UnsupportedOperationException("You do not have the ability to remove an item"));
     	}
     	
        }

//test stack

   public static void main(String[] args) {
               CTStack s1 = new CTStack();
               String name;

               s1.push("Alice");
               s1.add("Bob");
               s1.push("Carol");
               System.out.println(s1);
               System.out.println("s1.hashCode: " + s1.hashCode());
               System.out.println("Empty? " + s1.isEmpty());

               System.out.println("\ns1 Iterator test:");
               Iterator iter = s1.iterator();
               while (iter.hasNext()) {
                       name = (String)iter.next();
                       System.out.println(name);
               }

               System.out.println("\nLooking at three stacks");
               CTStack s2 = new CTStack();
               s2.addAll(s1);
               System.out.println("\ns2 Iterator test:");
               iter = s2.iterator();
               while (iter.hasNext()) {
                       name = (String)iter.next();
                       System.out.println(name);
               }
               CTStack s3 = new CTStack();
               s3.addAll(s2);
               System.out.println("\ns3 Iterator test:");
               iter = s3.iterator();
               while (iter.hasNext()) {
                       name = (String)iter.next();
                       System.out.println(name);
               }

               System.out.println("s1 equals s2? " + s1.equals(s2));
               System.out.println("s1 equals s3? " + s1.equals(s3));
               System.out.println("s1.hashCode: " + s1.hashCode());
               System.out.println("s2.hashCode: " + s2.hashCode());
               System.out.println("s3.hashCode: " + s3.hashCode());
               System.out.println("Is Bob in s1? " + s1.contains("Bob"));
               s1.add("Doug");
               System.out.println(s1.peek());
               System.out.println("s1.hashCode: " + s1.hashCode());
               System.out.println("s2.hashCode: " + s2.hashCode());
               System.out.println("s3.hashCode: " + s3.hashCode());
               System.out.println("s1 equals s2? " + s1.equals(s2));
               System.out.println("s1 equals s3? " + s1.equals(s3));
               System.out.println("Is s1 contained in s2? " + s2.containsAll(s1));
               System.out.println("Is s2 contained in s1? " + s1.containsAll(s2));
               System.out.println("Is s2 contained in s3? " + s3.containsAll(s3));

               System.out.println("\nLooking at an array and a stack");
               Object[] names = s1.toArray();
               for (int i=0; i<names.length; i++) {
                       System.out.println(names[i]);
               }


               System.out.println("\nEmptying the stacks");
               System.out.println(s1.pop());
               System.out.println(s1.hashCode());
               System.out.println(s1.pop());
               System.out.println(s1.pop());
               System.out.println(s1.pop());
               System.out.println("Empty? " + s1.isEmpty());
               s2.clear();
               System.out.println("Empty? " + s2.isEmpty());
               System.out.println("s1 equals s2? " + s1.equals(s2));
               System.out.println("s1.hashCode: " + s1.hashCode());
               System.out.println("s2.hashCode: " + s2.hashCode());

       }
}
