import java.util.*;
import java.lang.reflect.Array;
 
public class DWllStack extends M865Stack {
	protected Link top;
	
	private class Link {
		Link next;
		Object data;
		
		Link(Link lnk, Object obj) {
			next = lnk;
			data = obj;
		}
		
		Link(Object obj) {
			next = null;
			data = obj;
		}

		Link() {
			next = null;
			data = null;
		}
	}
	
	public DWllStack() {
		top = new Link( new Integer(0));
	}
	
	protected DWllStack(Link topOfLinkedList) {
		top = topOfLinkedList;
	}
	
	public void push(Object o) {
	// pushes an object onto the stack.
		Link lnk = new Link(top.next, o);
		top.next = lnk;
		top.data = new Integer(1+((Integer)top.data).intValue());
	}
	
	public Object pop() {
	// removes and returns the object on the top of the stack.
	// returns null if the stack is empty.
		if (top.next == null) {
			return null;
		} else {
			Object o = top.next.data;
			top.next = top.next.next;
			top.data = new Integer(((Integer)top.data).intValue()-1);
			return o;
		}
	}
	
	public Object peek() {
	// returns the object on the top of the stack.
	// returns null if the stack is empty.
		if (top.next == null) {
			return null;
		} else {
			return top.next.data;
		}
	}

	public boolean add(Object o) {
	// Ensures that this collection contains the specified element.
		this.push( o );
		return true;
	}
	
	public boolean addAll(Collection c) {
	// Adds all of the elements in the specified collection to this stack
		Iterator ci = c.iterator();
		boolean changed = ci.hasNext();
		while (ci.hasNext()) {
			this.push( ci.next() );
		}
		return changed;
	}
	
	public void clear() {
	// Removes all of the elements from this collection (optional operation). 
		Link t;
	}
		
	public Object clone() {
	// Returns a copy of this stack
		Link newTop = new Link(new Integer(((Integer)top.data).intValue()));
		Link newLink = newTop;
		Link oldLink = top;
		while (oldLink.next != null) {
			if (oldLink.data instanceof Cloneable) {
				tmpLink = new Link(((Cloneable)oldLink.data).clone());
			} else {
				tmpLink = new Link(oldLink.data);
			}
			newLink.next = tmpLink;
			newLink = tmpLink;
		}
		return (new DWllStack(newTop));
	}
	
	public boolean contains(Object o) {
	// Returns true if this collection contains the specified element.  
		return v.contains(o);
	}
	
	public boolean containsAll(Collection c) {
	// Returns true if this collection contains all of the elements in the
	// specified collection. 
		return v.containsAll(c);
	}
	 
	public boolean equals(Object o) {
	// Compares the specified object with this collection for equality. 
		boolean b = (o instanceof DWllStack) && (this.size() == ((DWllStack)o).size());
		if (b) {
			Iterator i = this.iterator();
			Iterator j = ((DWllStack)o).iterator();
			while (b && i.hasNext()) {
				b = (i.next()).equals(j.next());
			}
		}
		return b;
	}
	
	public int hashCode() {
	// Returns the hash code value for this collection.  
		return top.hashCode();
	}
	
	public boolean isEmpty() {
	// Returns true if this collection contains no elements.  
		return (top.next == null);
	}
	
	public class DWllStackIterator implements Iterator {
		private DWllStack myStack;
		private Link index;
		private int check;
		
		DWllStackIterator(DWllStack s) {
			myStack = s;
			index = myStack.top.next;
			// check = myStack.hashCode();
		}

		public boolean hasNext() {
			return (index.next != null);
		}
		
		public Object next() {
			Object o = index.data;
			index = index.next;
			return o;
		}
		
		public void remove() {
	// Removes the last element returned by the iterator.
	// This is an optional operation which is not implemented for DWllStackIterator.
			throw( new UnsupportedOperationException("remove is not implemented for the general M865Stack"));
		}
	}

	public Iterator iterator() {
	// Returns an iterator over the elements in this collection.  
		return new DWllStackIterator(this);
	}
	
	public int size() {
	// Returns the number of elements in this collection.  
		return ((Integer)top.data).inValue();
	}
	
	public Object[] toArray() {
	// Returns an array containing all of the elements in this collection.
		Object[] A = new Object[this.size()];
		Iterator i = this.iterator();
		int k=0;
		while (i.hasNext()) {
			A[k++] = i.next();
		}
		return A;
	}
	/*
	public Object[] toArray(Object[] a) {
	// Returns an array containing all of the elements in this collection; 
	//the runtime type of the returned array is that of the specified array.
		int i = v.size();
		int k = 0;
		if (i <= a.length) {
			while (0<i) {
				a[k++] = v.get(--i);
			}
			if (v.size() < a.length) {
				a[k] = null;
			}
			return a;
		} else {
			Class c = a.getClass();
			c = c.getComponentType();
			Object[] A = (Object[])Array.newInstance(c, i);
			while (0<i) {
				A[k++] = v.get(--i);
			}
			return A;
		}
	}
	*/
	public String toString() {
		String s = "DWllStack {";
		Iterator i = this.iterator();
		while (i.hasNext()) {
			s += "\n	" + i.next().toString();
		}
		return (s + "\n}");
	}
	
	public static void main(String[] args) {
		DWllStack s1 = new DWllStack();
		String name;
		
		s1.push("Alice");
		s1.add("Bob");
		s1.push("Carol");
		System.out.println(s1);
		System.out.println("s1.hashCode: " + s1.hashCode());
		System.out.println("Empty? " + s1.isEmpty());
		 
		System.out.println("\ns1 Iterator test:");
		Iterator iter = s1.iterator();
		while (iter.hasNext()) {
			name = (String)iter.next();
			System.out.println(name);
		}
		
		System.out.println("\nLooking at three stacks");
		DWllStack s2 = new DWllStack();
		s2.addAll(s1);
		System.out.println("\ns2 Iterator test:");
		iter = s2.iterator();
		while (iter.hasNext()) {
			name = (String)iter.next();
			System.out.println(name);
		}
		DWllStack s3 = new DWllStack();
		s3.addAll(s2);
		System.out.println("\ns3 Iterator test:");
		iter = s3.iterator();
		while (iter.hasNext()) {
			name = (String)iter.next();
			System.out.println(name);
		}

		System.out.println("s1 equals s2? " + s1.equals(s2));
		System.out.println("s1 equals s3? " + s1.equals(s3));
		System.out.println("s1.hashCode: " + s1.hashCode());
		System.out.println("s2.hashCode: " + s2.hashCode());
		System.out.println("s3.hashCode: " + s3.hashCode());
		System.out.println("Is Bob in s1? " + s1.contains("Bob"));
		s1.add("Doug");
		System.out.println(s1.peek());
		System.out.println("s1.hashCode: " + s1.hashCode());
		System.out.println("s2.hashCode: " + s2.hashCode());
		System.out.println("s3.hashCode: " + s3.hashCode());
		System.out.println("s1 equals s2? " + s1.equals(s2));
		System.out.println("s1 equals s3? " + s1.equals(s3));
		System.out.println("Is s1 contained in s2? " + s2.containsAll(s1));
		System.out.println("Is s2 contained in s1? " + s1.containsAll(s2));
		System.out.println("Is s2 contained in s3? " + s3.containsAll(s3));
		
		System.out.println("\nLooking at cloning");
		DWllStack s4 = (DWllStack)s1.clone();
		System.out.println("s1 equals s4? " + s1.equals(s4));
		System.out.println("s1.hashCode: " + s1.hashCode());
		System.out.println("s4.hashCode: " + s4.hashCode());
		System.out.println("s4.pop: " + s4.pop());
		System.out.println("s1 equals s4? " + s1.equals(s4));
		System.out.println("s1.hashCode: " + s1.hashCode());
		System.out.println("s4.hashCode: " + s4.hashCode());

		System.out.println("\nLooking at an array and a stack");
		Object[] names = s1.toArray();
		for (int i=0; i<names.length; i++) {
			System.out.println(names[i]);
		}
		String[] moreNames = (String[])s1.toArray(new String[5]);
		System.out.println("moreNames.length: " + moreNames.length);
		for (int i=0; i<moreNames.length; i++) {
			System.out.println(moreNames[i]);
		}


		System.out.println("\nEmptying the stacks");
		System.out.println(s1.pop());
		System.out.println(s1.hashCode());
		System.out.println(s1.pop());
		System.out.println(s1.pop());
		System.out.println(s1.pop());
		System.out.println("Empty? " + s1.isEmpty());
		s2.clear();
		System.out.println("Empty? " + s2.isEmpty());
		System.out.println("s1 equals s2? " + s1.equals(s2));
		System.out.println("s1.hashCode: " + s1.hashCode());
		System.out.println("s2.hashCode: " + s2.hashCode());

	}
}