import java.io.*;
import java.util.*;


public class DWInputTree {
	public Vector vertexSet;
	public Edge[] edgeList;
	

	public DWInputTree() {
		vertexSet = new Vector();
		edgeList = null;
	}
	
	public void readEdges(SimpleReader input)
		throws IOException {

		char ch;
		int c;
		Character sName = null;
		Character tName = null;
		Vector listOfEdges = new Vector();
		int state = 0;
		// i'm assuming the edges are inputed as 'a b'
		while ((c = input.read()) != -1) {
			ch = (char)c;
			// add ch to vertex list if not already there
			if ((state == 0) && ('a' <= ch) && (ch <= 'z')) {
				sName = new Character(ch);
				if (!vertexSet.contains(sName)) {
					vertexSet.add(sName);
				}
				state = 1;
			}
			if ((state == 1) && (ch == ' ')) {
				state = 2;
			}
			if ((state == 2) && ('a' <= ch) && (ch <= 'z')) {
				tName = new Character(ch);
				if (!vertexSet.contains(tName)) {
					vertexSet.add(tName);
				}
				Edge e = new Edge(sName,tName);
				if (!listOfEdges.contains(e)) {
					listOfEdges.add(e);
				}
				state = 3;
			}
			if ((state == 3) && ((ch == '\n') || (ch == '\r'))) {
				state = 0;
			}
		}
		edgeList = new Edge[listOfEdges.size()];
		edgeList = (Edge[])listOfEdges.toArray(edgeList);
		// Since Characters are Comparable, and since the Edge class
		// implements Comparable in a lexicographic order, the Arrays
		// sort method will work. This is a static method.
		Arrays.sort(edgeList);
	}

	public static void main (String args[])
		throws IOException {
		SimpleReader input;
		if (0 < args.length) {
			input = new SimpleReader(args[0]);
		} else {
			input = new SimpleReader();
		}
		DWInputTree t = new DWInputTree();
		t.readEdges(input);
		int nV = t.vertexSet.size();
		int nE = t.edgeList.length;
		System.out.println("For Vertex set: " + t.vertexSet);
		System.out.println("with " + nE + " edges");
		System.out.println("The Edgelist is:  ");
		for (int k=0; k<nE; k++) {
			System.out.println("   " + t.edgeList[k]);
		}
		if (nE == nV - 1){
			System.out.println("This could be a tree.");
		}else{ 
			System.out.println("This is not a tree.");
		}
	}
}
