/** The concrete myRectangle class. */

import java.awt.*;

public class MyRectangle extends MyShape{
	
	MyRectangle(int x, int y, int w, int h, Color c) {
		super(x, y, w, h, c);
	}
	
	MyRectangle(int x, int y) {
		super(x, y, defaultWidth, defaultHeight, defaultColor);
	}
	
	void draw(Graphics g) {
		g.setColor(this.color);
		g.fillRect(this.x, this.y, this.wide, this.high);  
	}

	public float area() {
		return( wide*high );
	}
	
	public float perimeter() {
		return( 2*(wide + high) );
	}

	public String toString() {
		return( "Rectangle:  " + super.toString() );
	}
	
	public static void main(String args[]) {
		int x0 = 10;
		int y0 = 10;
		int w0 = defaultWidth;
		int h0 = defaultHeight;
		if (args.length > 1) {
			x0 = Integer.parseInt(args[0]);
			y0 = Integer.parseInt(args[1]);
		}
		if (args.length > 3) {
			w0 = Integer.parseInt(args[2]);
			h0 = Integer.parseInt(args[3]);
		}
		MyRectangle r = new MyRectangle(x0, y0, w0, h0, defaultColor);
		System.out.println(r);
		System.out.println("The area is: " + r.area());
		System.out.println("The preimenter is: " + r.perimeter());
	}
}
