import java.io.*;

public class XMLPrint{
	protected InputStreamReader inputStream;
	XMLScanner xml;
	M865Stack s;
	String indent;

	public XMLPrint(String fileName) throws IOException {
		inputStream = new FileReader(fileName);
		xml = new XMLScanner(inputStream);
		s = new DWvStack();
		indent = " ";
	}

	public XMLPrint() throws IOException {
		inputStream = new InputStreamReader(System.in);
		xml = new XMLScanner(inputStream);
		s = new DWvStack();
		indent = " ";
	}

	public void run() 
		throws IOException {

		int token;
		
		while ((token = xml.scan()) != XMLScanner.EOF) {
			switch(token) {
				case XMLScanner.STARTTAG:
					s.push(xml.tag);
					System.out.println(indent + xml.scannedString);
					indent = indent + "|   ";
					break;
				case XMLScanner.ENDTAG:
					if (xml.tag.equals((String)s.peek())) {
						indent = indent.substring(4);
						System.out.println(indent + xml.scannedString);
						s.pop();
					} else {
						System.out.println("*** Mismatched Tags ***");
						return ;
					}
					break;
				case XMLScanner.SINGLETAG:
				case XMLScanner.MISC:
					System.out.println(indent + xml.scannedString);
					break;					
				case XMLScanner.BADTAG:
					System.out.println("*** Malformed Tag ***");
					return ;
			}
		}
		if (!s.isEmpty()) {
			System.out.println("*** Unbalanced Tags ***");
		}
	}

	
	public static void main (String args[]) 
		throws IOException {

		XMLPrint xmlPrinter;
		if (0 < args.length) {
			xmlPrinter = new XMLPrint(args[0]);
		} else {
			xmlPrinter = new XMLPrint();
		}
		xmlPrinter.run();		
   }
}
