public class MillisecondTimer {

/*******

    This class provides a stopwatch useful for
    timing the performance of pieces of a program.
    
 *******/
 
     protected long startTime;
     protected long elapsedTime = 0;
     protected boolean timerState = true;
     protected long cummualativeElapsedTime = 0;
     
     public MillisecondTimer() {
     
         startTime = System.currentTimeMillis();
         timerState = false;  
     }
     
     public void startTimer() {
         startTime = System.currentTimeMillis();
         elapsedTime = 0;
         timerState = true;
     }
     
     public long stopTimer() {
         if ( timerState ) {
             // if timer is running, stop it and record the elapsed time.
             long stopTime = System.currentTimeMillis();
             elapsedTime = stopTime - startTime;
             cummualativeElapsedTime += elapsedTime;
             timerState = false;
         }
         return elapsedTime;
     }
     
     public long getElapsedTime() {
         if ( timerState ) {
             // if timer is running, get the current elapsed time.
             long currentTime = System.currentTimeMillis();
             elapsedTime = currentTime - startTime;
         }
         return elapsedTime;
     }
     
     public long getCummualativeElapsedTime() {
         if ( timerState ) {
             return ( cummualativeElapsedTime + this.getElapsedTime());
         } else {
             return cummualativeElapsedTime;
         }
     }
          
     public void resetTimer() {
         startTime = System.currentTimeMillis();
         elapsedTime = 0;
         timerState = false;
         cummualativeElapsedTime = 0;
     }
 
     public static void main(String[] args) {
         MillisecondTimer t1 = new MillisecondTimer();
         double s, n, term;
         long temp[];
         temp = new long[10];
         t1.startTimer();
         s = 1.0;
         n = 1.0;
         term = 1.0;
         for (int k1 = 0; k1<10; k1++) {
             for (int k2=0; k2<100000; k2++) {
                 n += 1.0;
                 term = term/n;
                 s += term;
             }
             temp[k1] = t1.getElapsedTime();
         }
         long closingTime = t1.stopTimer();
         System.out.println("Timer test - computer e to 1,000,000 terms");
         for (int k3=0; k3<10; k3++) {
             System.out.println(((k3+1)*100000) + " terms: " + temp[k3] + " msec.");
         }
         System.out.println("Closing time: " + closingTime + " msec.");
     }
            
 }
