/*        
    This program reads a file and prints out each
    valid Fortran Floating Point litteral.
    
    Daniel D. Warner   9/6/98
*/

import java.io.*;

public class SpotFloats {

    static final int DIG=0, SGN=1, DEC=2, eEdD=3, OTHR=4;
    static final int stateTransitionFunction[][] = {
        { 1, 1, 1, 6, 6, 8, 6, 8, 8, 6},
        { 2, 2, 2, 2, 2, 7, 2, 2, 2, 2},
        { 3, 4, 9, 3, 3, 3, 3, 3, 3, 3},
        { 0, 5, 0, 0, 5, 0, 5, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}};
    
    public static void main(String args[]) {
        InputStreamReader stdin = new InputStreamReader(System.in);
        int count=1, val=0, state = 0;
        char c;
        Integer lineNumber;

        lineNumber = new Integer(count);
        String buf = lineNumber.toString() + ": ";
        while (val != -1) {
            try {
                val = stdin.read();
                if (val == -1) {
                    System.out.println("\nEOF");
                } else if (((char)val == ' ') || ((char)val == '\t')) {
                    // Simply skip white space.
                } else {
                    c = (char)val;
                    state = stateTransitionFunction[classifyCharacter(c)][state];
                    switch ( state ) {
                        case 0: {
                            buf = "\n" + lineNumber.toString() + ": ";
                            break;
                        }
                        case 1: case 4: case 6: case 8: case 9:{
                            buf = buf + c;
                            System.out.print(buf);
                            buf = "";
                            break;
                        }
                        case 2: case 3: {
                            buf = "\n" + lineNumber.toString() + ": " + c;
                            break;
                        }
                        case 5: case 7: {
                            buf = buf + c;
                            break;
                        }
                    }
                    if (c == '\n') {
                        count++;
                        lineNumber = new Integer(count);
                    }
                }
            } catch (IOException e) {} 
        }
    }

    public static int classifyCharacter(char c) {
        if (('0' <= c) && (c <= '9')) {
            return DIG;
        } else if ((c == '+') || (c == '-')) {
            return SGN;
        } else if (c=='.') {
            return DEC;
        } else if ((c=='e') || (c=='E') || (c=='d') || (c=='D')) {
            return eEdD;
        } else {
            return OTHR;
        }
    }
}
